import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Calendar;
import java.util.GregorianCalendar;

/*
 * Created on Mar 21, 2006
 */

/**
 * @author }TCP{Wolf
 * <br>
 * <br>
 * This program was written as a demonstration how easy it is to receive text/
 * letters over an IP network.<br>
 * This program is by no means valueable, do with it what you will. I declare
 * it freeware to be used in whatever purpose you want.<br>
 * My intention was to demonstrate how to receive data, so people can program
 * their own programs or scripts or whatever and here they can see the "basics"
 * of that.<br>
 * <br>
 * For example: Run this program on port 23 and telnet to your localhost (or
 * whichever machine you run it on). Whatever you type will be displayed on
 * the console. Not pretty but you get the point :-) Now... just consider there
 * is longer text coming in so evaluate it. IP Rules etc is all up to you,
 * it's possible to program IP Filters in java too, though firewall rules
 * are probably a lot simpler :-P User name/password? Come up with something
 * yourself lol!
 */

public class netecho
{
    public static char delim, replacement;                      // character delimeter and the replacement if the data contains it by accident
    public static String default_serverNameKey = "shortname";   // what key we look for in the data to determine the server name
    public static String default_mapNameKey = "mapname";        // which key declares the mapname
    public static String serverNameKey, mapNameKey;
    
    /**
     * Main program, start it to listen for incoming network traffic. To start,
     * use "java netecho [port]" and replace [port] with a valid and non-used
     * port on your computer.<br>
     * <br>
     * Note: You will need to have "." in your classpath for ease of use.<br>
     * @param args
     * [port] - port number to listen for incoming connections <br>
     * [delimeter] - the textual delimeter between data entries
     */
    
    
    public static void main(String[] args)
    {
        // check arguments
        if (args.length < 3)
        {
            o("USAGE:");
            o("java netecho [port] [delimeter] [replacement] [servernamekey] [mapnamekey]");
            return; // exit
        }
        
        int port = -1;
        try
        {port = Integer.parseInt(args[0]);}
        catch (NumberFormatException idiot)
        {
            o("That doesn't appear to be a port number...");
            return;
        }
        
        // valid port number?
        if ((port<1)||(port>65535))
        {
            o("Dude you're getting on me nerves with your silly parameters...");
            return;
        }
        
        // get delimter
        delim = args[1].charAt(0);
        replacement = args[2].charAt(0);

        o("Delimeter is: "+delim);
        o("Replacement character for delimeter inside data is: "+replacement);

        if (args.length>3) serverNameKey = args[3];
        else serverNameKey = default_serverNameKey;
        if (args.length>4) mapNameKey = args[4];
        else mapNameKey = default_mapNameKey;
        o("Server name data key is: "+serverNameKey);
        o("Map name data key is: "+mapNameKey);
        
        // great we got a port number then... let's start listening...
        ServerSocket ss = null;
        try
        {ss = new ServerSocket(port);}
        catch (IOException e)
        {
            o("Failed to bind port "+port);
            return;
        }
        
        o("Listening on port "+port);
        o("Terminate program by hitting CRL-C or just kill the process...");
        
        //ss.setSoTimeout(12345)	// if you want to, set a server socket timeout here!
        while(true) // this is an infinate loop, bad style! Hit CTRL-C to abort/exit program for now
        {
            Socket newSocket = null;
            try
            {newSocket = ss.accept();}
            catch (IOException e1)
            {o("Some error happened here: "+e1.getMessage());}
            if (newSocket != null)	// got an incoming VALID connection
            {
                o("Accepted connection from "+newSocket.getRemoteSocketAddress().toString());
                netecho useless = new netecho();
                // echoWriter blah = new echoWriter(newSocket); // this will not work for java screwup reason :rolleyes:
                // so we have to instantiate it this way... pffffft
                echoWriter blah = useless.new echoWriter(newSocket);
                blah.start(); // start the thread
            }
        }
        
        // put cleanup code here if you eliminate the infiniate loop above
        // and make yourself nice exiting criteria
        // for now these lines are unreachable of course
        
        //try{ss.close();} catch (IOException e2){/*do nothing*/}
        //o("Cya...");
    }
    
    
    
    
    /**
     * This internal class does nothing except take an established connection
     * (from the MAIN program) and write every text it receives over the network
     * on the default output.<br>
     * <br>
     * This is a primitive "conceptional" program to demonstrate you can send
     * text over IP networks easily...
     */
    public class echoWriter extends Thread
    {
        private Socket s;	// that's the network socket all the text comes in from...
        
        // constructor
        public echoWriter(Socket newSocket)
        {
            s = newSocket;
        }
        
        
        /*
         * The run() method is called from main after start() by the java
         * engine. run() is the function to execute all what the application
         * does in this additional thread... in our case: write whatever text
         * comes over the network on the screen.
         */
        public void run()
        {
            InputStream in = null;
            try
            {in = s.getInputStream();}
            catch (IOException eek)
            {
                o("Failed to acquire input from socket!");
                //just for good measure: close the socket again to terminate any pending connection
                //if closing fails, no worries then it was already closed, so don't do anything...
                try
                {s.close();}
                catch(IOException e)
                {}
                return;	// terminate this thread
            }
            
            // we successfully got an input stream...
            boolean bDone = false;
            StringBuffer theData = new StringBuffer();      // this is where we are going to put all the data in
            while (!bDone && s.isConnected() && (in != null))	// as long as the socket is not closed...
            {
                byte b[] = new byte[256];
                int bytesRead = 0;
                try {bytesRead = in.read(b);}
                catch (IOException e)
                {
                    o("Connection "+s.getRemoteSocketAddress().toString()+" failed/terminated.");
                    try{s.close();}catch(IOException e3){}
                    writeDataToLogFile(theData.toString());
                    return;	// terminate this thread
                }
                if (bytesRead > 0)
                {
                    //o(s.getRemoteSocketAddress().toString()+": "+bytearray2string(b));
                    theData.append(bytearray2string(b));
                }
                else
                    bDone = true; // read 0 bytes -> nothing to get anymore...
            }
            
            o("Connection "+s.getRemoteSocketAddress().toString()+" closed.");
            writeDataToLogFile(theData.toString());
            try{s.close();}catch(IOException e3){}
            return;	// terminate this thread
        }
    }
    
    
    
    /**
     * A non-elegant way to create text strings out of bytes...
     * @param b
     * @return
     */
    public static String bytearray2string(byte[] b)
    {
        StringBuffer sb = new StringBuffer();
        for(int i=0; ((i<b.length)&&(b[i]!=0)); i++) sb.append((char)b[i]);
        return sb.toString();
    }
    
    
    /**
     * Simple method to write a string into a file...
     */
    public static String WriteFile(String FileName, String FileContent, boolean append)
    {
        FileWriter myFW;
        try
        {
            myFW=new FileWriter(FileName,append);
            myFW.write(FileContent);
            myFW.close();
        }
        catch (IOException e)
        {return new String("ERROR:ioexception  ** Message: "+e.getMessage());}
        return new String("ok");
    } // end WriteFile
    
    
    /**
     * Creates a nicely formatted Date string looking like
     * YYYYMMDD_HHMMSS
     */
    public static String getDateString()
    {
        GregorianCalendar cal = new GregorianCalendar();
        StringBuffer sb = new StringBuffer();
        sb.append(cal.get(Calendar.YEAR));
        int i = cal.get(Calendar.MONTH) + 1;
        sb.append(add0num(i));
        i = cal.get(Calendar.DAY_OF_MONTH);
        sb.append(add0num(i)+"_");
        i = cal.get(Calendar.HOUR_OF_DAY);
        sb.append(add0num(i));
        i = cal.get(Calendar.MINUTE);
        sb.append(add0num(i));
        i = cal.get(Calendar.SECOND);
        sb.append(add0num(i));
        return sb.toString();
    }
    
    /**
     * formats numbers with a leading 0 if necessary
     */
    public static String add0num(int i)
    {
        if (i<10) return ("0"+i);
        return (""+i);
    }
    
    
    /**
     * called with the entire piece of data to be written onto disk...
     */
    public static void writeDataToLogFile(String data)
    {
        // determing filename - YYYYMMDD_HHMMSS_ServerName_MapName
        String fileName = getDateString()+"_"+findData(data, serverNameKey)+"_"+findData(data, mapNameKey)+".log";
        // first, we need to clear away any "accidental" delimeters that may be in the data
        String subst = searchReplace(data, delim, replacement);
        // we need to replace the gameSpy delim with our own...
        subst = searchReplace(subst, '\\', delim);
        o("Trying to write file: "+fileName);
        String result = WriteFile(fileName,subst,false);
        o(result);
    }
    
    
    /**
     * finds specific data from the gameSpy protocol type data...
     * for example, we can look for the server name in the data stream and
     * get that as a result...
     */
    public static String findData(String text, String lookfor)
    {
        int location = text.indexOf("\\"+lookfor+"\\"); // we are looking for the KEY in the data
        if (location <0) return ("unknown");    // text we were looking for was not found... return substitute
        // we need to acquire the key value then....
        int startoffset = location+2+lookfor.length();
        int loc2 = text.indexOf('\\',startoffset);
        String value = null;
        if (loc2 < 0) value = text.substring(startoffset);
        else value = text.substring(startoffset,loc2);
        return value;
    }

    
    /**
     * A very primite character search and replace function...
     */
    public static String searchReplace(String source, char search, char replace)
    {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i<source.length(); i++)
        {
            if (source.charAt(i) == search) sb.append(replace);
            else sb.append(source.charAt(i));
        }
        return sb.toString();
    }
    
    
    // I am too lazy to keep writing sys out everywhere...
    public static void o(String what)
    {System.out.println(what);}
}
